import java.util.*;

public class Graphen {

	public static void main(String[] args) {
		
		Knoten[] l_weg;
		Knoten[] wege = new Knoten[16];
	
		System.out.println("Starte ...");
		for (int index = 0; index < 16; index++) {
			wege[index] = new Knoten();
			wege[index].konf = index;
			if (gueltige_konf(index)) {
				wege[index].gueltig = true;
			}
		}
		System.out.println ("Erstelle Graphen !");
		erstelle_graph (wege, wege[0]);
		int g_kanten = 0;
		for (int index = 0; index < 16; index++) {
			wege[index].besucht = false;
			for (int kanten = 0; kanten < 4; kanten++) {
				if (wege[index].kanten[kanten] != null)
					g_kanten++;
			}
		}
		System.out.println ("16 Knoten ...");
		System.out.println (g_kanten + " Kanten ...");
		System.out.println ("Starte BFS ...");
		int l_tiefe;
		l_tiefe = bfs_suche(wege[0]);
		System.out.println ("Lsung mit Lnge " + l_tiefe + " gefunden");
		System.out.println ("Erstelle Lsungsweg");
		l_weg = new Knoten[l_tiefe + 1];
		generiere_lweg(wege[0], l_weg, l_tiefe);
		for (int index = 0; index <= l_tiefe; index++)
			System.out.println (l_weg[index]);
	}
	
	public static boolean generiere_lweg (Knoten g, Knoten[] l_weg, int max_depth) {
		
		int index;
		
		if (g.tiefe > max_depth) 
			return false;
		l_weg[g.tiefe] = g;
		if (g.konf == 15)
			return true;
		for (index = 0; index < 4; index++) 
			if (g.kanten[index] != null)
				if (generiere_lweg(g.kanten[index], l_weg, max_depth))
					return true;
		return false;
	}

	public static int bfs_suche (Knoten g) {
		
		Knoten k;
		LinkedList l = new LinkedList();
		int index, tiefe = 0;
		
		if (g == null)
			return 0;
		g.tiefe = 0;
		l.add(g);
	
		// bfs, baut den graphen gleichzeitig um
		
		while (!l.isEmpty()) {
			k = (Knoten)l.removeFirst(); 
			k.besucht = true;
			if (k.konf == 15)
				tiefe = k.tiefe;
			for (index = 0; index < 4; index++) {
				if (k.kanten[index] != null) {
					if (!k.kanten[index].besucht) {
						k.kanten[index].tiefe = k.tiefe + 1;
						l.add(k.kanten[index]);
					}
					else {
						k.kanten[index] = null;
					}
				}
			}
		}
		return tiefe;
	}
	
	public static void erstelle_graph (Knoten[] f_g, Knoten g) {
		
		int seite;
		int a_konf = g.konf;
		int o_konf = a_konf;
	
		g.besucht = true;	
		seite = (o_konf & 0x8) >> 3;
		// der mann fhrt auf jedenfall wieder zurck
		//				mann umdrehen		+ alter zustand					
		a_konf = ((~(a_konf & 0x8)) & 0x8) | (a_konf & 0x7);		
		
		if (f_g[a_konf].gueltig) {
			// knoten verknpfen
			g.kanten[0] = f_g[a_konf]; 
			// wenn er noch nicht besucht war dort rekursiv weiter
			if (!f_g[a_konf].besucht)
				erstelle_graph (f_g, f_g[a_konf]);
		}
		int n_konf;
		// einfach alles durchprobieren jetzt was man(n) noch mitnehmen knnte
		for (int objekte = 0; objekte < 3; objekte ++) {
			if (((o_konf & (1 << objekte)) >> objekte) == seite) {
				n_konf = (1 << objekte);
				// ausselektieren was man(n) nach links oder rechts mitnimmt
				if (seite == 0)
					n_konf = (n_konf | a_konf) & 0xf;
				else
					n_konf = (a_konf & (~n_konf)) & 0xf; 
				
				if (f_g[n_konf].gueltig) {
					// knoten verknpfen
					g.kanten[objekte + 1] = f_g[n_konf]; 
					// wenn er noch nicht besucht war dort rekursiv weiter
					if (!f_g[n_konf].besucht)
						erstelle_graph (f_g, f_g[n_konf]);
				}
			}
		}
	}
	
	public static boolean gueltige_konf (int konfiguration) {
		
	/* Links = 0; Rechts = 1
	 * Mann Kohl Wolf Schaf : 0000 - 1111 = 0 .. 15 MSB - LSB
	 */
		int	mann	= 1 << 3;
		int kohl	= 1 << 2;
		int wolf	= 1 << 1;
		int schaf	= 1;
		int k = konfiguration;

		// rechte seite prfen
		if ((k & (kohl | schaf)) == (kohl | schaf) || 
			(k & (wolf | schaf)) == (wolf | schaf))
			if ((k & mann) == 0)
				return false;

		// linke seite;
		if	( ((~k & (kohl | schaf)) == (kohl | schaf)) || 
			  ((~k & (wolf | schaf)) == (wolf | schaf)))
			if ((~k & mann) == 0)
			return false;
		
		return true;
	}
}
